unit FormMain;

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Machine;

type

  { TFormMain }

  TFormMain = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    procedure SerialPortWrite(Data: Byte);
  public
    Machine: TMachine2;
  end;

var
  FormMain: TFormMain;


implementation

uses
  CpuBitWidth;

{$R *.lfm}

{ TFormMain }

procedure TFormMain.FormCreate(Sender: TObject);
begin
  Machine := TMachine2.Create;
  with Machine do begin
    Memory.Size := $10000;
    VideoMemory.Size := $4000;
    SystemMemory.Size := $1000;
    SerialPort.OnWrite := SerialPortWrite;
    with Cpu do begin
      Write1(Integer(inLoad1));
      Write1(Ord('A'));
      Write1(Integer(inOutput1));
      Write2($1);
      Write1(Integer(inHalt));
      Run;
    end;
  end;
end;

procedure TFormMain.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Machine);
end;

procedure TFormMain.SerialPortWrite(Data: Byte);
begin
  Memo1.Lines.Text := Memo1.Lines.Text + Chr(Data);
end;

end.

