unit SerialPort;

interface

uses
  Classes, SysUtils, Device;

type
  TReadEvent = function: Byte of object;
  TWriteEvent = procedure (B: Byte) of object;

  { TSerialPort1 }

  TSerialPort1 = class(TDevice1)
  private
    FOnRead: TReadEvent;
    FOnWrite: TWriteEvent;
  public
    procedure Write1(Address: Byte; Data: Byte); override;
    function Read1(Address: Byte): Byte; override;
    property OnWrite: TWriteEvent read FOnWrite write FOnWrite;
    property OnRead: TReadEvent read FOnRead write FOnRead;
  end;

  { TSerialPort2 }

  TSerialPort2 = class(TDevice2)
  private
    FOnRead: TReadEvent;
    FOnWrite: TWriteEvent;
  public
    procedure Write1(Address: Word; Data: Byte); override;
    procedure Write2(Address: Word; Data: Word); override;
    function Read1(Address: Word): Byte; override;
    function Read2(Address: Word): Word; override;
    property OnWrite: TWriteEvent read FOnWrite write FOnWrite;
    property OnRead: TReadEvent read FOnRead write FOnRead;
  end;

implementation

{ TSerialPort2 }

procedure TSerialPort2.Write1(Address: Word; Data: Byte);
begin
  if Assigned(FOnWrite) then FOnWrite(Data);
end;

procedure TSerialPort2.Write2(Address: Word; Data: Word);
begin
  if Assigned(FOnWrite) then FOnWrite(Data);
end;

function TSerialPort2.Read1(Address: Word): Byte;
begin
  if Assigned(FOnRead) then Result := FOnRead;
end;

function TSerialPort2.Read2(Address: Word): Word;
begin
  if Assigned(FOnRead) then Result := FOnRead;
end;

{ TSerialPort1 }

procedure TSerialPort1.Write1(Address: Byte; Data: Byte);
begin
  if Assigned(FOnWrite) then FOnWrite(Data);
end;

function TSerialPort1.Read1(Address: Byte): Byte;
begin
  if Assigned(FOnRead) then Result := FOnRead;
end;

end.

